## nghttp2 1.30.0

=== CMakeLists.txt ===
# nghttp2 - HTTP/2 C Library
#
# Copyright (c) 2012, 2013, 2014, 2015 Tatsuhiro Tsujikawa
# Copyright (c) 2016 Peter Wu <peter@lekensteyn.nl>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 3.0)
# XXX using 1.8.90 instead of 1.9.0-DEV
project(nghttp2 VERSION 1.30.0)

# See versioning rule:
#  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(LT_CURRENT  29)
set(LT_REVISION 2)
set(LT_AGE      15)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include(Version)

math(EXPR LT_SOVERSION "${LT_CURRENT} - ${LT_AGE}")
set(LT_VERSION "${LT_SOVERSION}.${LT_AGE}.${LT_REVISION}")
set(PACKAGE_VERSION     "${PROJECT_VERSION}")
HexVersion(PACKAGE_VERSION_NUM ${PROJECT_VERSION_MAJOR} ${PROJECT_VERSION_MINOR} ${PROJECT_VERSION_PATCH})

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build type" FORCE)

  # Include "None" as option to disable any additional (optimization) flags,
  # relying on just CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (which are empty by
  # default). These strings are presented in cmake-gui.
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

# For Python bindings and documentation
# (Must be called before PythonLibs for matching versions.)
find_package(PythonInterp)

# Auto-detection of features that can be toggled
find_package(OpenSSL 1.0.1)
find_package(Libev 4.11)
find_package(Libcares 1.7.5)
find_package(ZLIB 1.2.3)
if(OPENSSL_FOUND AND LIBEV_FOUND AND ZLIB_FOUND)
  set(ENABLE_APP_DEFAULT ON)
else()
  set(ENABLE_APP_DEFAULT OFF)
endif()
find_package(Jansson  2.5)
set(ENABLE_HPACK_TOOLS_DEFAULT ${JANSSON_FOUND})
# 2.0.8 is required because we use evconnlistener_set_error_cb()
find_package(Libevent 2.0.8 COMPONENTS libevent openssl)
set(ENABLE_EXAMPLES_DEFAULT ${LIBEVENT_OPENSSL_FOUND})
find_package(Cython)
find_package(PythonLibs)
if(CYTHON_FOUND AND PYTHONLIBS_FOUND)
  set(ENABLE_PYTHON_BINDINGS_DEFAULT ON)
else()
  set(ENABLE_PYTHON_BINDINGS_DEFAULT OFF)
endif()

find_package(LibXml2 2.6.26)
set(WITH_LIBXML2_DEFAULT    ${LIBXML2_FOUND})
find_package(Jemalloc)
set(WITH_JEMALLOC_DEFAULT   ${JEMALLOC_FOUND})
find_package(Spdylay 1.3.2)
set(WITH_SPDYLAY_DEFAULT    ${SPDYLAY_FOUND})

include(CMakeOptions.txt)

if(ENABLE_LIB_ONLY AND (ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_EXAMPLES OR
  ENABLE_PYTHON_BINDINGS))
  # Remember when disabled options are disabled for later diagnostics.
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 1)
else()
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 0)
endif()
if(ENABLE_LIB_ONLY)
  set(ENABLE_APP            OFF)
  set(ENABLE_HPACK_TOOLS    OFF)
  set(ENABLE_EXAMPLES       OFF)
  set(ENABLE_PYTHON_BINDINGS OFF)
endif()

# Do not disable assertions based on CMAKE_BUILD_TYPE.
foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
  foreach(_lang C CXX)
    string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" " " ${_var} "${${_var}}")
  endforeach()
endforeach()

if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(HINT_NORETURN       "__attribute__((noreturn))")
else()
  set(HINT_NORETURN)
endif()

include(ExtractValidFlags)
foreach(_cxx1x_flag -std=c++11 -std=c++0x)
  extract_valid_cxx_flags(_cxx1x_flag_supported ${_cxx1x_flag})
  if(_cxx1x_flag_supported)
    set(CXX1XCXXFLAGS ${_cxx1x_flag})
    break()
  endif()
endforeach()

include(CMakePushCheckState)
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_DEFINITIONS "${CXX1XCXXFLAGS}")
# Check that std::future is available.
check_cxx_source_compiles("
#include <vector>
#include <future>
int main() { std::vector<std::future<int>> v; }" HAVE_STD_FUTURE)
# Check that std::map::emplace is available for g++-4.7.
check_cxx_source_compiles("
#include <map>
int main() { std::map<int, int>().emplace(1, 2); }" HAVE_STD_MAP_EMPLACE)
cmake_pop_check_state()


# Checks for libraries.
# Additional libraries required for programs under src directory.
set(APP_LIBRARIES)

if(ENABLE_PYTHON_BINDINGS)
  if(NOT (CYTHON_FOUND AND PYTHONLIBS_FOUND))
    message(FATAL_ERROR "python bindings were requested "
      "(ENABLE_PYTHON_BINDINGS=1) but dependencies are not met.")
  endif()
  if(NOT PYTHON_VERSION_STRING STREQUAL PYTHONLIBS_VERSION_STRING)
    message(FATAL_ERROR
      "Python executable and library must have the same version!"
      " Found Python ${PYTHON_VERSION_STRING} and"
      " PythonLibs ${PYTHONLIBS_VERSION_STRING}"
    )
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  list(APPEND APP_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif()
# XXX android and C++, is this still needed in cmake?
# case "$host" in
#   *android*)
#     android_build=yes
#     # android does not need -pthread, but needs followng 3 libs for C++
#     APPLDFLAGS="$APPLDFLAGS -lstdc++ -latomic -lsupc++"

# dl: openssl requires libdl when it is statically linked.
# XXX shouldn't ${CMAKE_DL_LIBS} be appended to OPENSSL_LIBRARIES instead of
# APP_LIBRARIES if it is really specific to OpenSSL?

find_package(CUnit 2.1)
enable_testing()
set(HAVE_CUNIT      ${CUNIT_FOUND})
if(HAVE_CUNIT)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
endif()

# openssl (for src)
set(HAVE_OPENSSL    ${OPENSSL_FOUND})
if(OPENSSL_FOUND)
  set(OPENSSL_INCLUDE_DIRS  ${OPENSSL_INCLUDE_DIR})
else()
  set(OPENSSL_INCLUDE_DIRS  "")
  set(OPENSSL_LIBRARIES     "")
endif()
# libev (for src)
set(HAVE_LIBEV      ${LIBEV_FOUND})
set(HAVE_ZLIB       ${ZLIB_FOUND})
set(HAVE_LIBEVENT_OPENSSL ${LIBEVENT_FOUND})
if(LIBEVENT_FOUND)
  # Must both link the core and openssl libraries.
  set(LIBEVENT_OPENSSL_LIBRARIES ${LIBEVENT_LIBRARIES})
endif()
# libc-ares (for src)
set(HAVE_LIBCARES   ${LIBCARES_FOUND})
if(LIBCARES_FOUND)
  set(LIBCARES_INCLUDE_DIRS ${LIBCARES_INCLUDE_DIR})
else()
  set(LIBCARES_INCLUDE_DIRS "")
  set(LIBCARES_LIBRARIES    "")
endif()
# jansson (for src/nghttp, src/deflatehd and src/inflatehd)
set(HAVE_JANSSON    ${JANSSON_FOUND})
# libxml2 (for src/nghttp)
set(HAVE_LIBXML2    ${LIBXML2_FOUND})
if(LIBXML2_FOUND)
  set(LIBXML2_INCLUDE_DIRS  ${LIBXML2_INCLUDE_DIR})
else()
  set(LIBXML2_INCLUDE_DIRS  "")
  set(LIBXML2_LIBRARIES     "")
endif()
# jemalloc
set(HAVE_JEMALLOC   ${JEMALLOC_FOUND})
# spdylay (for src/nghttpx and src/h2load)
set(HAVE_SPDYLAY    ${SPDYLAY_FOUND})

if(ENABLE_ASIO_LIB)
  find_package(Boost 1.54.0 REQUIRED system thread)
endif()

# The nghttp, nghttpd and nghttpx under src depend on zlib, OpenSSL and libev
if(ENABLE_APP AND NOT (ZLIB_FOUND AND OPENSSL_FOUND AND LIBEV_FOUND))
  message(FATAL_ERROR "Applications were requested (ENABLE_APP=1) but dependencies are not met.")
endif()

# HPACK tools requires jansson
if(ENABLE_HPACK_TOOLS AND NOT HAVE_JANSSON)
  message(FATAL_ERROR "HPACK tools were requested (ENABLE_HPACK_TOOLS=1) but dependencies are not met.")
endif()

# C++ library libnghttp2_asio
if(ENABLE_EXAMPLES AND NOT (OPENSSL_FOUND AND LIBEVENT_OPENSSL_FOUND))
  message(FATAL_ERROR "examples were requested (ENABLE_EXAMPLES=1) but dependencies are not met.")
endif()

# third-party http-parser only be built when needed
if(ENABLE_EXAMPLES OR ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_ASIO_LIB)
  set(ENABLE_THIRD_PARTY 1)
  # mruby (for src/nghttpx)
  set(HAVE_MRUBY      ${WITH_MRUBY})
  set(HAVE_NEVERBLEED ${WITH_NEVERBLEED})
else()
  set(HAVE_MRUBY 0)
  set(HAVE_NEVERBLEED 0)
endif()

# Checks for header files.
include(CheckIncludeFile)
check_include_file("arpa/inet.h"    HAVE_ARPA_INET_H)
check_include_file("fcntl.h"        HAVE_FCNTL_H)
check_include_file("inttypes.h"     HAVE_INTTYPES_H)
check_include_file("limits.h"       HAVE_LIMITS_H)
check_include_file("netdb.h"        HAVE_NETDB_H)
check_include_file("netinet/in.h"   HAVE_NETINET_IN_H)
check_include_file("pwd.h"          HAVE_PWD_H)
check_include_file("sys/socket.h"   HAVE_SYS_SOCKET_H)
check_include_file("sys/time.h"     HAVE_SYS_TIME_H)
check_include_file("syslog.h"       HAVE_SYSLOG_H)
check_include_file("time.h"         HAVE_TIME_H)
check_include_file("unistd.h"       HAVE_UNISTD_H)

include(CheckTypeSize)
# Checks for typedefs, structures, and compiler characteristics.
# AC_TYPE_SIZE_T
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to "int" to match the behavior of AC_TYPE_SSIZE_T (autotools).
  set(ssize_t int)
endif()
# AC_TYPE_UINT8_T
# AC_TYPE_UINT16_T
# AC_TYPE_UINT32_T
# AC_TYPE_UINT64_T
# AC_TYPE_INT8_T
# AC_TYPE_INT16_T
# AC_TYPE_INT32_T
# AC_TYPE_INT64_T
# AC_TYPE_OFF_T
# AC_TYPE_PID_T
# AC_TYPE_UID_T
# XXX To support inline for crappy compilers, see https://cmake.org/Wiki/CMakeTestInline
# AC_C_INLINE
# XXX is AC_SYS_LARGEFILE still needed for modern systems?
# add_definitions(-D_FILE_OFFSET_BITS=64)

include(CheckStructHasMember)
check_struct_has_member("struct tm" tm_gmtoff time.h HAVE_STRUCT_TM_TM_GMTOFF)

# Check size of pointer to decide we need 8 bytes alignment adjustment.
check_type_size("int *"   SIZEOF_INT_P)
check_type_size("time_t"  SIZEOF_TIME_T)

# Checks for library functions.
include(CheckFunctionExists)
check_function_exists(_Exit     HAVE__EXIT)
check_function_exists(accept4   HAVE_ACCEPT4)
check_function_exists(mkostemp  HAVE_MKOSTEMP)

include(CheckSymbolExists)
# XXX does this correctly detect initgroups (un)availability on cygwin?
check_symbol_exists(initgroups grp.h HAVE_DECL_INITGROUPS)
if(NOT HAVE_DECL_INITGROUPS AND HAVE_UNISTD_H)
  # FreeBSD declares initgroups() in unistd.h
  check_symbol_exists(initgroups unistd.h HAVE_DECL_INITGROUPS2)
  if(HAVE_DECL_INITGROUPS2)
    set(HAVE_DECL_INITGROUPS 1)
  endif()
endif()

set(WARNCFLAGS)
set(WARNCXXFLAGS)
if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_WERROR)
    set(WARNCFLAGS    /WX)
    set(WARNCXXFLAGS  /WX)
  endif()
else()
  if(ENABLE_WERROR)
    extract_valid_c_flags(WARNCFLAGS    -Werror)
    extract_valid_c_flags(WARNCXXFLAGS  -Werror)
  endif()

  # For C compiler
  extract_valid_c_flags(WARNCFLAGS
    -Wall
    -Wextra
    -Wmissing-prototypes
    -Wstrict-prototypes
    -Wmissing-declarations
    -Wpointer-arith
    -Wdeclaration-after-statement
    -Wformat-security
    -Wwrite-strings
    -Wshadow
    -Winline
    -Wnested-externs
    -Wfloat-equal
    -Wundef
    -Wendif-labels
    -Wempty-body
    -Wcast-align
    -Wclobbered
    -Wvla
    -Wpragmas
    -Wunreachable-code
    -Waddress
    -Wattributes
    -Wdiv-by-zero
    -Wshorten-64-to-32

    -Wconversion
    -Wextended-offsetof
    -Wformat-nonliteral
    -Wlanguage-extension-token
    -Wmissing-field-initializers
    -Wmissing-noreturn
    -Wmissing-variable-declarations
    # Not used because we cannot change public structs
    # -Wpadded
    -Wsign-conversion

=== integration-tests/CMakeLists.txt ===
set(GO_FILES
  nghttpx_http1_test.go
  nghttpx_http2_test.go
  nghttpx_spdy_test.go
  server_tester.go
)

# XXX unused
set(EXTRA_DIST
  ${GO_FILES}
  server.key
  server.crt
  alt-server.key
  alt-server.crt
  setenv
  req-set-header.rb
  resp-set-header.rb
  req-return.rb
  resp-return.rb
)

add_custom_target(itprep
  COMMAND go get -d -v golang.org/x/net/http2
  COMMAND go get -d -v github.com/tatsuhiro-t/go-nghttp2
  COMMAND go get -d -v github.com/tatsuhiro-t/spdy
  COMMAND go get -d -v golang.org/x/net/websocket
)

# 'go test' requires both config.go and the test files in the same directory.
# For out-of-tree builds, config.go is normally not placed next to the source
# files, so copy the tests to the build directory as a workaround.
set(GO_BUILD_FILES)
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  foreach(gofile IN LISTS GO_FILES)
    set(outfile "${CMAKE_CURRENT_BINARY_DIR}/${gofile}")
    add_custom_command(OUTPUT "${outfile}"
      COMMAND ${CMAKE_COMMAND} -E copy
              "${CMAKE_CURRENT_SOURCE_DIR}/${gofile}" "${outfile}"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${gofile}"
    )
    list(APPEND GO_BUILD_FILES "${outfile}")
  endforeach()
endif()

add_custom_target(it
  COMMAND sh setenv go test -v
  DEPENDS ${GO_BUILD_FILES}
)

=== debian/changelog ===
nghttp2 (1.30.0-1ubuntu1~ubuntu14.04.1~ppa4) trusty; urgency=medium

  * Backport to trusty:
    - Use debhelper 9.
    - Disable systemd

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Tue, 09 Oct 2018 12:14:22 +0200

nghttp2 (1.30.0-1ubuntu1) bionic; urgency=medium

  * SECURITY UPDATE: DoS via too large frame
    - debian/patches/CVE-2018-1000168.patch: fix frame handling in
      lib/nghttp2_frame.c, add test to tests/nghttp2_session_test.c.
    - CVE-2018-1000168

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 10 Apr 2018 13:45:02 -0400

nghttp2 (1.30.0-1) unstable; urgency=medium

  * Imported upstream version 1.30.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 12 Feb 2018 13:44:16 +0100

nghttp2 (1.29.0-1) unstable; urgency=medium

  * Imported upstream version 1.29.0
  * Bumped Standards-Version to 4.1.2 (no changes needed)
  * Updated debhelper compat to 11
  * d/patches: use python3 for fetch-ocsp-response

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 02 Jan 2018 12:43:09 +0100

nghttp2 (1.28.0-1) unstable; urgency=medium

  * Imported upstream version 1.28.0
  * Bumped Standards-Version to 4.1.1 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 03 Dec 2017 13:34:25 +0100

nghttp2 (1.27.0-1) unstable; urgency=medium

  * Imported upstream version 1.27.0
  * Bumped Standards-Version to 4.1.0 (no changes needed)

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 27 Oct 2017 22:12:09 +0200

nghttp2 (1.26.0-1) unstable; urgency=medium

  * Imported upstream version 1.26.0

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 21 Sep 2017 09:34:29 +0200

=== debian/control ===
Source: nghttp2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper (>= 9),
               libc-ares-dev,
               libcunit1-dev (>= 2.1),
               libev-dev (>= 1:4.15),
               libevent-dev (>= 2.0.8),
               libjansson-dev (>= 2.5),
               libjemalloc-dev [!hurd-i386],
               libspdylay-dev (>= 1.3.2),
               libssl-dev (>= 1.0.1),
               libxml2-dev (>= 2.7.7),
               pkg-config,
               zlib1g-dev (>= 1.2.3)
Build-Depends-Indep: python3-sphinx, python3-sphinxcontrib.rubydomain
Standards-Version: 4.1.2
Homepage: https://nghttp2.org/
Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
Vcs-Browser: https://salsa.debian.org/debian/nghttp2

Package: libnghttp2-dev
Suggests: libnghttp2-doc
Section: libdevel
Architecture: any
Conflicts: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Replaces: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Depends: libnghttp2-14 (= ${binary:Version}), pkg-config, ${misc:Depends}
Description: library implementing HTTP/2 protocol (development files)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs development files.

Package: libnghttp2-doc
Section: doc
Architecture: all
Depends: libjs-jquery, libjs-underscore, lynx | www-browser, ${misc:Depends}
Description: library implementing HTTP/2 protocol (documentation)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs documentation.

Package: libnghttp2-14
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing HTTP/2 protocol (shared library)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs a shared library.

Package: nghttp2-client
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: client implementing HTTP/2 protocol
 This is a command line client implementing the HTTP/2 protocol. It
 gives access to many low-level and advanced aspects of the protocol
 and therefore is useful for debugging.

Package: nghttp2-proxy
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         openssl,
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: reverse proxy implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 as a frontend in front of web servers that do not support HTTP/2.

Package: nghttp2-server
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base (>= 3.2-14),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nghttp2 (<< 1.3.4-2~)
Breaks: nghttp2 (<< 1.3.4-2~)
Description: server implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 to serve files from a local directory.

Package: nghttp2
Architecture: all
Depends: nghttp2-client (>= ${binary:Version}),
         nghttp2-proxy (>= ${binary:Version}),
         nghttp2-server (>= ${binary:Version}),
         ${misc:Depends}
Description: server, proxy and client implementing HTTP/2
 This package will install a set of programs implementing the HTTP/2
 protocol: a standalone server (nghttp2-server), a reverse proxy
 (nghttp2-proxy) and a client (nghttp2-client). It provides no files
 on its own and is not necessary for these programs to work.

=== debian/rules ===
#!/usr/bin/make -f

# this makes the tests fail
# LDFLAGS += -Wl,--default-symver

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-python-bindings=no --disable-failmalloc --enable-app --with-spdylay

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	$(MAKE) html

# don't run tests when building indep packages
override_dh_auto_test-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/manual/html doc/manual/doctrees doc/apiref.rst

override_dh_auto_install-arch: custom_install_init_scripts
	dh_auto_install

override_dh_auto_install-indep: custom_install_manual

override_dh_installinit:
	dh_installinit -pnghttp2-proxy --onlyscripts --name=nghttpx

.PHONY: custom_install_manual custom_install_init_scripts

DOCDIR="debian/libnghttp2-doc/usr/share/doc/libnghttp2-doc"
custom_install_manual:
	mkdir -p $(DOCDIR)
	cp -pr doc/manual/html/* $(DOCDIR)
	rm $(DOCDIR)/objects.inv
	ln -sf /usr/share/javascript/jquery/jquery.js $(DOCDIR)/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js $(DOCDIR)/_static/underscore.js

ETCDIR="debian/nghttp2-proxy/etc"
custom_install_init_scripts:
	install -d $(ETCDIR)/init.d
	sed -e 's,^DAEMON=.*/,DAEMON=/usr/sbin/,' contrib/nghttpx-init > $(ETCDIR)/init.d/nghttpx
	chmod 755 $(ETCDIR)/init.d/nghttpx
	install -d $(ETCDIR)/nghttpx
	# we install our own version of config
	install -m644 debian/nghttpx.conf $(ETCDIR)/nghttpx/nghttpx.conf
	install -d $(ETCDIR)/logrotate.d
	install -p -m644 contrib/nghttpx-logrotate $(ETCDIR)/logrotate.d/nghttpx

%:
	dh $@

## nghttp2 1.32.0

=== debian/changelog ===
nghttp2 (1.32.0-1) unstable; urgency=medium

  * Imported upstream version 1.32.0

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 19 May 2018 15:01:25 +0200

nghttp2 (1.31.1-1) unstable; urgency=medium

  * Imported upstream version 1.31.1 (fixes CVE-2018-1000168)

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 21 Apr 2018 19:35:33 +0200

nghttp2 (1.31.0-1) unstable; urgency=medium

  * Imported upstream version 1.31.0
  * Update symbols of libnghttp2

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 06 Mar 2018 00:06:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,23 @@
 Source: nghttp2
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
+Maintainer: Tomasz Buchert <tomasz@debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11),
+               dpkg-dev (>= 1.17.14),
                libc-ares-dev,
-               libcunit1-dev (>= 2.1),
+               libcunit1-dev (>= 2.1) <!nocheck>,
                libev-dev (>= 1:4.15),
                libevent-dev (>= 2.0.8),
                libjansson-dev (>= 2.5),
                libjemalloc-dev [!hurd-i386],
                libspdylay-dev (>= 1.3.2),
                libssl-dev (>= 1.0.1),
+               libsystemd-dev,
                libxml2-dev (>= 2.7.7),
                pkg-config,
                zlib1g-dev (>= 1.2.3)
-Build-Depends-Indep: python3-sphinx, python3-sphinxcontrib.rubydomain
+Build-Depends-Indep: python3-sphinx
 Standards-Version: 4.1.2
 Homepage: https://nghttp2.org/
 Vcs-Git: https://salsa.debian.org/debian/nghttp2.git

## nghttp2 1.32.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,13 @@
 
 cmake_minimum_required(VERSION 3.0)
 # XXX using 1.8.90 instead of 1.9.0-DEV
-project(nghttp2 VERSION 1.30.0)
+project(nghttp2 VERSION 1.32.1)
 
 # See versioning rule:
 #  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  29)
-set(LT_REVISION 2)
-set(LT_AGE      15)
+set(LT_CURRENT  30)
+set(LT_REVISION 3)
+set(LT_AGE      16)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 include(Version)

=== debian/changelog ===
nghttp2 (1.32.1-1build1) cosmic; urgency=high

  * No change rebuild against openssl 1.1.1 with TLS 1.3 support.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 29 Sep 2018 01:36:54 +0100

nghttp2 (1.32.1-1) unstable; urgency=medium

  * Imported upstream version 1.32.1
  * Update debian control with "cme fix dpkg-control"

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 01 Sep 2018 12:02:10 +0200

=== debian/control ===
Source: nghttp2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>
Section: httpd
Priority: optional
Build-Depends: debhelper (>= 11),
               dpkg-dev (>= 1.17.14),
               libc-ares-dev,
               libcunit1-dev <!nocheck>,
               libev-dev (>= 1:4.15),
               libevent-dev,
               libjansson-dev (>= 2.5),
               libjemalloc-dev [!hurd-i386],
               libspdylay-dev,
               libssl-dev,
               libsystemd-dev,
               libxml2-dev,
               pkg-config,
               zlib1g-dev
Build-Depends-Indep: python3-sphinx
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/nghttp2
Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
Homepage: https://nghttp2.org/

Package: libnghttp2-dev
Architecture: any
Section: libdevel
Depends: libnghttp2-14 (= ${binary:Version}), pkg-config, ${misc:Depends}
Suggests: libnghttp2-doc
Conflicts: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Replaces: libnghttp2-3-dev, libnghttp2-4-dev, libnghttp2-5-dev
Description: library implementing HTTP/2 protocol (development files)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs development files.

Package: libnghttp2-doc
Architecture: all
Section: doc
Depends: libjs-jquery, libjs-underscore, lynx | www-browser, ${misc:Depends}
Description: library implementing HTTP/2 protocol (documentation)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs documentation.

Package: libnghttp2-14
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library implementing HTTP/2 protocol (shared library)
 This is an implementation of the Hypertext Transfer Protocol version
 2 in C. The framing layer of HTTP/2 is implemented as a reusable C
 library.
 .
 This package installs a shared library.

Package: nghttp2-client
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: client implementing HTTP/2 protocol
 This is a command line client implementing the HTTP/2 protocol. It
 gives access to many low-level and advanced aspects of the protocol
 and therefore is useful for debugging.

Package: nghttp2-proxy
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base,
         openssl,
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: reverse proxy implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 as a frontend in front of web servers that do not support HTTP/2.

Package: nghttp2-server
Architecture: any
Multi-Arch: foreign
Depends: libnghttp2-14 (= ${binary:Version}),
         lsb-base,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: nghttp2 (<< 1.3.4-2~)
Replaces: nghttp2 (<< 1.3.4-2~)
Description: server implementing HTTP/2 protocol
 This is a standalone server implementing the HTTP/2 protocol with
 HTTP/1.1 fallback for clients that do not support it. It can be used
 to serve files from a local directory.

Package: nghttp2
Architecture: all
Depends: nghttp2-client (>= ${binary:Version}),
         nghttp2-proxy (>= ${binary:Version}),
         nghttp2-server (>= ${binary:Version}),
         ${misc:Depends}
Description: server, proxy and client implementing HTTP/2
 This package will install a set of programs implementing the HTTP/2
 protocol: a standalone server (nghttp2-server), a reverse proxy
 (nghttp2-proxy) and a client (nghttp2-client). It provides no files
 on its own and is not necessary for these programs to work.

## nghttp2 1.34.0

=== debian/changelog ===
nghttp2 (1.34.0-1) unstable; urgency=medium

  * Imported upstream version 1.34.0

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 11 Oct 2018 08:04:01 +0200

nghttp2 (1.33.0-1) unstable; urgency=medium

  * Imported upstream version 1.33.0

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 07 Sep 2018 00:49:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: nghttp2
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
+Maintainer: Tomasz Buchert <tomasz@debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional

## nghttp2 1.35.1

=== debian/changelog ===
nghttp2 (1.35.1-1) unstable; urgency=medium

  * New upstream version 1.35.1

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 14 Dec 2018 10:03:56 +0100

nghttp2 (1.35.0-1) unstable; urgency=medium

  * New upstream version 1.35.0

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 26 Nov 2018 00:35:43 +0100

## nghttp2 1.36.0

=== python/CMakeLists.txt ===
# EXTRA_DIST = cnghttp2.pxd nghttp2.pyx

if(ENABLE_PYTHON_BINDINGS)
  add_custom_target(python ALL
    COMMAND "${PYTHON_EXECUTABLE}" setup.py build
    VERBATIM
    DEPENDS nghttp2.c nghttp2
  )

  configure_file(install-python.cmake.in install-python.cmake ESCAPE_QUOTES @ONLY)
  install(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/install-python.cmake")

  add_custom_command(OUTPUT nghttp2.c
    COMMAND "${CYTHON_EXECUTABLE}" -o nghttp2.c
      "${CMAKE_CURRENT_SOURCE_DIR}/nghttp2.pyx"
    VERBATIM
    DEPENDS nghttp2.pyx
  )

  # Instead of calling "setup.py clean --all", this should do...
  set_directory_properties(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "build;python_nghttp2.egg-info"
  )

## This works also, except that the installation target is missing...
#  include(UseCython)
#  cython_add_module(python_nghttp2 nghttp2.pyx)
#  set_target_properties(python_nghttp2 PROPERTIES
#    OUTPUT_NAME nghttp2
#  )
#  target_include_directories(python_nghttp2 PRIVATE
#    "${CMAKE_SOURCE_DIR}/lib"
#    "${CMAKE_SOURCE_DIR}/lib/includes"
#    "${CMAKE_BINARY_DIR}/lib/includes"
#  )
#  target_link_libraries(python_nghttp2
#    nghttp2
#  )
endif()

=== debian/changelog ===
nghttp2 (1.36.0-2+deb10u3) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * Fix CVE-2024-28182: An implementation using the nghttp2 library will
    continue to receive CONTINUATION frames, and will not callback to the
    application to allow visibility into this information before it resets the
    stream, resulting in Denial of Service. (Closes: #1068415)
  * d/libnghttp2-14.symbols: Add missig symbol from the backported upstream
    fix.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 30 Apr 2024 18:59:06 +0200

nghttp2 (1.36.0-2+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * Backport upstream fixes for CVE-2020-11080 (Closes: #962145).
  * Backport upstream fix for CVE-2023-44487 (Closes: #1053769).
  * Add three new symbols from backported fixes to libnghttp2-14.symbols.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 16 Oct 2023 13:34:24 +0100

nghttp2 (1.36.0-2+deb10u1) buster-security; urgency=high

  * Fix CVE-2019-9511 and CVE-2019-9513.

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 23 Aug 2019 17:52:43 +0200

nghttp2 (1.36.0-2) unstable; urgency=medium

  * d/*: drop support for spdy (Closes: #920988)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 03 Feb 2019 10:53:17 -0800

nghttp2 (1.36.0-1) unstable; urgency=medium

  * Packaging refresh (debhelper 12, std-ver 4.3.0)
  * New upstream release 1.36.0

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 23 Jan 2019 09:32:13 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12),
+               debhelper-compat (= 12),
                dpkg-dev (>= 1.17.14),
                libc-ares-dev,
                libcunit1-dev <!nocheck>,
@@ -11,14 +12,13 @@
                libevent-dev,
                libjansson-dev (>= 2.5),
                libjemalloc-dev [!hurd-i386],
-               libspdylay-dev,
                libssl-dev,
                libsystemd-dev,
                libxml2-dev,
                pkg-config,
                zlib1g-dev
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian/nghttp2
 Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
 Homepage: https://nghttp2.org/
@@ -85,6 +85,7 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Breaks: nghttp2 (<< 1.3.4-2~)
+Pre-Depends: ${misc:Pre-Depends}
 Replaces: nghttp2 (<< 1.3.4-2~)
 Description: reverse proxy implementing HTTP/2 protocol
  This is a standalone server implementing the HTTP/2 protocol with

## nghttp2 1.36.0.1

=== lib/CMakeLists.txt ===
add_subdirectory(includes)

include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/includes"
)

add_definitions(-DBUILDING_NGHTTP2)

set(NGHTTP2_SOURCES
  nghttp2_pq.c nghttp2_map.c nghttp2_queue.c
  nghttp2_frame.c
  nghttp2_buf.c
  nghttp2_stream.c nghttp2_outbound_item.c
  nghttp2_session.c nghttp2_submit.c
  nghttp2_helper.c
  nghttp2_npn.c
  nghttp2_hd.c nghttp2_hd_huffman.c nghttp2_hd_huffman_data.c
  nghttp2_version.c
  nghttp2_priority_spec.c
  nghttp2_option.c
  nghttp2_callbacks.c
  nghttp2_mem.c
  nghttp2_http.c
  nghttp2_rcbuf.c
  nghttp2_debug.c
)

set(NGHTTP2_RES "")

if(WIN32)
  configure_file(
    version.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/version.rc
    @ONLY)

  set(NGHTTP2_RES ${CMAKE_CURRENT_BINARY_DIR}/version.rc)
endif()

# Public shared library
if(ENABLE_SHARED_LIB)
  add_library(nghttp2 SHARED ${NGHTTP2_SOURCES} ${NGHTTP2_RES})
  set_target_properties(nghttp2 PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    C_VISIBILITY_PRESET hidden
  )
  target_include_directories(nghttp2 INTERFACE
    "${CMAKE_CURRENT_BINARY_DIR}/includes"
    "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  )

  install(TARGETS nghttp2
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

if(HAVE_CUNIT OR ENABLE_STATIC_LIB)
  # Static library (for unittests because of symbol visibility)
  add_library(nghttp2_static STATIC ${NGHTTP2_SOURCES})
  set_target_properties(nghttp2_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    ARCHIVE_OUTPUT_NAME nghttp2
  )
  target_compile_definitions(nghttp2_static PUBLIC "-DNGHTTP2_STATICLIB")
  if(ENABLE_STATIC_LIB)
    install(TARGETS nghttp2_static
      DESTINATION "${CMAKE_INSTALL_LIBDIR}")
  endif()
endif()


install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp2.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
nghttp2 (1.36.0.1-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 96bd6d6e6de7c03cbf3cbc978af9439f143b8b16']

 -- shuttle <shuttle@deepin.com>  Thu, 30 Jul 2020 14:19:38 +0000

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		--enable-python-bindings=no --disable-failmalloc --enable-app --with-spdylay
+		--enable-python-bindings=no --disable-failmalloc --enable-app
 
 override_dh_auto_build-arch:
 	dh_auto_build
@@ -20,7 +20,7 @@
 	dh_auto_clean
 	rm -rf doc/manual/html doc/manual/doctrees doc/apiref.rst
 
-override_dh_auto_install-arch: custom_install_init_scripts
+override_dh_auto_install-arch: custom_install_init_scripts custom_install_systemd
 	dh_auto_install
 
 override_dh_auto_install-indep: custom_install_manual
@@ -28,7 +28,7 @@
 override_dh_installinit:
 	dh_installinit -pnghttp2-proxy --onlyscripts --name=nghttpx
 
-.PHONY: custom_install_manual custom_install_init_scripts
+.PHONY: custom_install_manual custom_install_init_scripts custom_install_systemd
 
 DOCDIR="debian/libnghttp2-doc/usr/share/doc/libnghttp2-doc"
 custom_install_manual:
@@ -49,5 +49,15 @@
 	install -d $(ETCDIR)/logrotate.d
 	install -p -m644 contrib/nghttpx-logrotate $(ETCDIR)/logrotate.d/nghttpx
 
+# Currently we install our own systemd unit because
+# the original one is slightly broken
+SYSTEMD="debian/nghttp2-proxy/lib/systemd/system"
+custom_install_systemd:
+	install -d $(SYSTEMD)
+	install -p -m644 debian/nghttpx.service $(SYSTEMD)/nghttpx.service
+
 %:
 	dh $@
+
+override_dh_dwz:
+

## nghttp2 1.37.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,13 @@
 
 cmake_minimum_required(VERSION 3.0)
 # XXX using 1.8.90 instead of 1.9.0-DEV
-project(nghttp2 VERSION 1.32.1)
+project(nghttp2 VERSION 1.37.0)
 
 # See versioning rule:
 #  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  30)
-set(LT_REVISION 3)
-set(LT_AGE      16)
+set(LT_CURRENT  31)
+set(LT_REVISION 2)
+set(LT_AGE      17)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 include(Version)
@@ -117,7 +117,7 @@
 endif()
 
 include(ExtractValidFlags)
-foreach(_cxx1x_flag -std=c++11 -std=c++0x)
+foreach(_cxx1x_flag -std=c++14)
   extract_valid_cxx_flags(_cxx1x_flag_supported ${_cxx1x_flag})
   if(_cxx1x_flag_supported)
     set(CXX1XCXXFLAGS ${_cxx1x_flag})

=== debian/changelog ===
nghttp2 (1.37.0-1) unstable; urgency=medium

  * New upstream release 1.37.0

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 17 Mar 2019 12:41:37 +0100

## nghttp2 1.39.1

=== debian/changelog ===
nghttp2 (1.39.1-1) experimental; urgency=medium

  * New upstream release 1.39.1

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 22 Jun 2019 13:14:11 +0200

nghttp2 (1.38.0-1) experimental; urgency=medium

  * New upstream release 1.38.0

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 05 May 2019 16:45:50 +0200

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,9 @@
                dpkg-dev (>= 1.17.14),
                libc-ares-dev,
                libcunit1-dev <!nocheck>,
-               libev-dev (>= 1:4.15),
+               libev-dev,
                libevent-dev,
-               libjansson-dev (>= 2.5),
+               libjansson-dev,
                libjemalloc-dev [!hurd-i386],
                libssl-dev,
                libsystemd-dev,
@@ -84,8 +84,8 @@
          python3,
          ${misc:Depends},
          ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Breaks: nghttp2 (<< 1.3.4-2~)
-Pre-Depends: ${misc:Pre-Depends}
 Replaces: nghttp2 (<< 1.3.4-2~)
 Description: reverse proxy implementing HTTP/2 protocol
  This is a standalone server implementing the HTTP/2 protocol with

## nghttp2 1.39.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,13 +24,13 @@
 
 cmake_minimum_required(VERSION 3.0)
 # XXX using 1.8.90 instead of 1.9.0-DEV
-project(nghttp2 VERSION 1.37.0)
+project(nghttp2 VERSION 1.39.2)
 
 # See versioning rule:
 #  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
-set(LT_CURRENT  31)
-set(LT_REVISION 2)
-set(LT_AGE      17)
+set(LT_CURRENT  32)
+set(LT_REVISION 0)
+set(LT_AGE      18)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 include(Version)

=== debian/changelog ===
nghttp2 (1.39.2-1) unstable; urgency=medium

  * New upstream release 1.39.2 (Closes: #934762)

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 15 Aug 2019 21:14:38 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                pkg-config,
                zlib1g-dev
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/debian/nghttp2
 Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
 Homepage: https://nghttp2.org/

## nghttp2 1.40.0

=== debian/changelog ===
nghttp2 (1.40.0-1ubuntu0.3) focal-security; urgency=medium

  * SECURITY UPDATE: HTTP/2 protocol denial of service
    - debian/patches/CVE-2024-28182-1.patch: Add
      nghttp2_option_set_max_continuations
    - debian/patches/CVE-2024-28182-2.patch: Limit CONTINUATION frames
      following an incoming HEADER frame
    - CVE-2024-28182

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Thu, 18 Apr 2024 09:15:36 +0200

nghttp2 (1.40.0-1ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: HTTP/2 protocol denial of service
    - debian/patches/CVE-2023-44487.patch: implement stream reset rate
      limiting.
    - CVE-2023-44487

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 11 Oct 2023 17:39:46 -0400

nghttp2 (1.40.0-1ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2020-11080-[1-2].patch: fixed a denial of service,
      potentially caused by large SETTINGS frames, in the module
    - CVE-2020-11080

 -- Amir Naseredini <amir.naseredini@canonical.com>  Wed, 31 May 2023 17:41:38 +0100

nghttp2 (1.40.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:51:32 +0100

nghttp2 (1.40.0-1) unstable; urgency=medium

  * New upstream release 1.40.0

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 19 Nov 2019 09:15:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: nghttp2
-Maintainer: Tomasz Buchert <tomasz@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional
@@ -18,10 +19,11 @@
                pkg-config,
                zlib1g-dev
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/debian/nghttp2
 Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
 Homepage: https://nghttp2.org/
+Rules-Requires-Root: no
 
 Package: libnghttp2-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -58,6 +58,3 @@
 
 %:
 	dh $@
-
-override_dh_dwz:
-

=== debian/tests/control ===
Tests: proxy-works
Depends: nginx, @
Restrictions: isolation-container

=== debian/watch ===
version=4
  https://github.com/tatsuhiro-t/nghttp2/releases .*/nghttp2-(\d\S*)\.tar\.bz2

## nghttp2 1.41.0

=== debian/changelog ===
nghttp2 (1.41.0-3) unstable; urgency=medium

  [ Jérémy Lal ]
  * not-installed with wildcard arch

  [ Tomasz Buchert ]
  * workaround for #963648

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 16 Aug 2020 13:01:37 +0200

nghttp2 (1.41.0-2) unstable; urgency=medium

  * Fix FTBFS of arch-indep packages (Closes: #962137)
  * Fix FTBFS on non-x86 archs (Closes: #962136)
  * Use debhelper 13

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 04 Jun 2020 08:13:51 +0200

nghttp2 (1.41.0-1) unstable; urgency=medium

  [ Tomasz Buchert ]
  * New upstream release 1.41.0

  [ Janusz Dziemidowicz ]
  * Perform graceful upgrade of nghttpx
  * fix systemd restart on debhelper >= 12

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 03 Jun 2020 17:03:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: nghttp2
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Tomasz Buchert <tomasz@debian.org>
+Maintainer: Tomasz Buchert <tomasz@debian.org>
 Uploaders: Ondřej Surý <ondrej@debian.org>
 Section: httpd
 Priority: optional
-Build-Depends: debhelper (>= 12),
-               debhelper-compat (= 12),
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (= 13),
                dpkg-dev (>= 1.17.14),
                libc-ares-dev,
                libcunit1-dev <!nocheck>,
@@ -19,7 +18,7 @@
                pkg-config,
                zlib1g-dev
 Build-Depends-Indep: python3-sphinx
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/nghttp2
 Vcs-Git: https://salsa.debian.org/debian/nghttp2.git
 Homepage: https://nghttp2.org/

## nghttp2 1.42.0

=== debian/changelog ===
nghttp2 (1.42.0-1) unstable; urgency=medium

  * New upstream release 1.42.0
  * Refresh patches

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 28 Nov 2020 16:41:28 +0100
